package org.seamcat.epp;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JTabbedPane;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.awt.GridBagLayout;
import javax.swing.JRadioButton;
import java.awt.GridBagConstraints;
import javax.swing.JSeparator;
import java.awt.Insets;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JEditorPane;
import javax.swing.LayoutStyle.ComponentPlacement;

import org.seamcat.calculator.Calculator;

import java.awt.Color;
import java.awt.Font;

public class TestFrame extends Thread implements ActionListener, ChangeListener {

	private JFrame frmPassResultsTo;
	private JTabbedPane tabbedPane;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JRadioButton rbt1;
	private JRadioButton rbt2;
	private JRadioButton rbt3;
	private JCheckBox chk1;
	private JCheckBox chk2;
	private JCheckBox chk3;
	private JEditorPane editorPane;
	private JButton btnClose;
	private JButton btnCalc;
	private JButton btnPass;
	private JButton btnSwitch;
	private boolean[] selectedParams = new boolean[3];
	private int selectedFactor;
	private TestFrameCalc calculator;
	private JPanel panel1;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					TestFrame window = new TestFrame();
					window.frmPassResultsTo.setVisible(false);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public TestFrame() {

		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmPassResultsTo = new JFrame();
		frmPassResultsTo.setTitle("pass results to EPP");
		frmPassResultsTo.setBounds(100, 100, 450, 300);
		frmPassResultsTo.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		btnClose = new JButton("close window before starting the next simulation");
		btnClose.setBackground(Color.pink);
		btnClose.addActionListener(this);
		frmPassResultsTo.getContentPane().add(btnClose, BorderLayout.SOUTH);

		tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		tabbedPane.addChangeListener(this);
		frmPassResultsTo.getContentPane().add(tabbedPane, BorderLayout.CENTER);

		panel1 = new JPanel();
		tabbedPane.addTab("New tab 1   ", null, panel1, null);
		GridBagLayout gbl_panel1 = new GridBagLayout();
		gbl_panel1.columnWidths = new int[] { 0, 0, 0, 0, 0, 0, 0 };
		gbl_panel1.rowHeights = new int[] { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
		gbl_panel1.columnWeights = new double[] { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE };
		gbl_panel1.rowWeights = new double[] { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE };
		panel1.setLayout(gbl_panel1);

		JSeparator separator = new JSeparator();
		GridBagConstraints gbc_separator = new GridBagConstraints();
		gbc_separator.insets = new Insets(0, 0, 5, 5);
		gbc_separator.gridx = 1;
		gbc_separator.gridy = 0;
		panel1.add(separator, gbc_separator);

		rbt1 = new JRadioButton("*1");
		buttonGroup.add(rbt1);
		GridBagConstraints gbc_rbt1 = new GridBagConstraints();
		gbc_rbt1.insets = new Insets(0, 0, 5, 5);
		gbc_rbt1.gridx = 1;
		gbc_rbt1.gridy = 1;
		panel1.add(rbt1, gbc_rbt1);

		chk1 = new JCheckBox("+0");
		chk1.setSelected(true);
		GridBagConstraints gbc_chk1 = new GridBagConstraints();
		gbc_chk1.anchor = GridBagConstraints.WEST;
		gbc_chk1.insets = new Insets(0, 0, 5, 0);
		gbc_chk1.gridx = 5;
		gbc_chk1.gridy = 1;
		panel1.add(chk1, gbc_chk1);

		JSeparator separator_1 = new JSeparator();
		GridBagConstraints gbc_separator_1 = new GridBagConstraints();
		gbc_separator_1.insets = new Insets(0, 0, 5, 5);
		gbc_separator_1.gridx = 1;
		gbc_separator_1.gridy = 2;
		panel1.add(separator_1, gbc_separator_1);

		rbt2 = new JRadioButton("*2");
		rbt2.setSelected(true);
		buttonGroup.add(rbt2);
		GridBagConstraints gbc_rbt2 = new GridBagConstraints();
		gbc_rbt2.insets = new Insets(0, 0, 5, 5);
		gbc_rbt2.gridx = 1;
		gbc_rbt2.gridy = 3;
		panel1.add(rbt2, gbc_rbt2);

		chk2 = new JCheckBox("+10");
		chk2.setSelected(true);
		GridBagConstraints gbc_chk2 = new GridBagConstraints();
		gbc_chk2.anchor = GridBagConstraints.WEST;
		gbc_chk2.insets = new Insets(0, 0, 5, 0);
		gbc_chk2.gridx = 5;
		gbc_chk2.gridy = 3;
		panel1.add(chk2, gbc_chk2);

		JSeparator separator_2 = new JSeparator();
		GridBagConstraints gbc_separator_2 = new GridBagConstraints();
		gbc_separator_2.insets = new Insets(0, 0, 5, 5);
		gbc_separator_2.gridx = 1;
		gbc_separator_2.gridy = 4;
		panel1.add(separator_2, gbc_separator_2);

		rbt3 = new JRadioButton("*5");
		buttonGroup.add(rbt3);
		GridBagConstraints gbc_rbt3 = new GridBagConstraints();
		gbc_rbt3.insets = new Insets(0, 0, 5, 5);
		gbc_rbt3.gridx = 1;
		gbc_rbt3.gridy = 5;
		panel1.add(rbt3, gbc_rbt3);

		chk3 = new JCheckBox("+20");
		chk3.setSelected(true);
		GridBagConstraints gbc_chk3 = new GridBagConstraints();
		gbc_chk3.anchor = GridBagConstraints.WEST;
		gbc_chk3.insets = new Insets(0, 0, 5, 0);
		gbc_chk3.gridx = 5;
		gbc_chk3.gridy = 5;
		panel1.add(chk3, gbc_chk3);

		btnSwitch = new JButton("switch to tab 2");
		btnSwitch.addActionListener(this);

		JSeparator separator_3 = new JSeparator();
		GridBagConstraints gbc_separator_3 = new GridBagConstraints();
		gbc_separator_3.insets = new Insets(0, 0, 5, 0);
		gbc_separator_3.gridx = 5;
		gbc_separator_3.gridy = 6;
		panel1.add(separator_3, gbc_separator_3);
		GridBagConstraints gbc_btnSwitch = new GridBagConstraints();
		gbc_btnSwitch.gridx = 5;
		gbc_btnSwitch.gridy = 7;
		panel1.add(btnSwitch, gbc_btnSwitch);

		JPanel panel2 = new JPanel();
		tabbedPane.addTab("New tab 2   ", null, panel2, null);

		editorPane = new JEditorPane();

		btnCalc = new JButton("calculate");
		btnCalc.addActionListener(this);

		btnPass = new JButton("pass results");
		btnPass.addActionListener(this);
		btnPass.setFont(new Font("Tahoma", Font.BOLD, 12));
		btnPass.setForeground(new Color(255, 0, 0));
		GroupLayout gl_panel2 = new GroupLayout(panel2);
		gl_panel2.setHorizontalGroup(gl_panel2.createParallelGroup(Alignment.LEADING).addGroup(
				gl_panel2.createSequentialGroup().addContainerGap().addComponent(editorPane, GroupLayout.PREFERRED_SIZE, 275, GroupLayout.PREFERRED_SIZE)
						.addPreferredGap(ComponentPlacement.RELATED).addGroup(gl_panel2.createParallelGroup(Alignment.LEADING).addComponent(btnCalc).addComponent(btnPass))
						.addContainerGap(49, Short.MAX_VALUE)));
		gl_panel2.setVerticalGroup(gl_panel2.createParallelGroup(Alignment.LEADING).addGroup(
				gl_panel2
						.createSequentialGroup()
						.addGroup(
								gl_panel2
										.createParallelGroup(Alignment.TRAILING)
										.addGroup(gl_panel2.createSequentialGroup().addContainerGap(109, Short.MAX_VALUE).addComponent(btnCalc).addGap(29).addComponent(btnPass))
										.addGroup(
												Alignment.LEADING,
												gl_panel2.createSequentialGroup().addContainerGap()
														.addComponent(editorPane, GroupLayout.PREFERRED_SIZE, 173, GroupLayout.PREFERRED_SIZE)))
						.addContainerGap(27, Short.MAX_VALUE)));
		panel2.setLayout(gl_panel2);
	}

	private TestFrameCalc getCalculator() {
		return calculator;
	}

	public JFrame getFrame() {
		return frmPassResultsTo;
	}

	public JTabbedPane getTabbedPane() {
		return tabbedPane;
	}

	public JRadioButton getRbt1() {
		return rbt1;
	}

	public JRadioButton getRbt2() {
		return rbt2;
	}

	public JRadioButton getRbt3() {
		return rbt3;
	}

	public JCheckBox getChk1() {
		return chk1;
	}

	public JCheckBox getChk2() {
		return chk2;
	}

	public JCheckBox getChk3() {
		return chk3;
	}

	public JEditorPane getEditorPane() {
		return editorPane;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		calculator = getCalculator();
		if (e.getSource() == getBtnClose()) {
			calculator.setPanelClosed(true);
			getFrame().dispose();
		}
		if (e.getSource() == getBtnSwitch()) {
			getTabbedPane().setSelectedIndex(1);
			getBtnPass().setEnabled(false);
		}

		if (e.getSource() == getBtnCalc()) {
			calculator.calculateResults();
			placeResultToEditor();
			getBtnPass().setEnabled(true);
		}
		if (e.getSource() == getBtnPass()) {
			calculator.getReadyForExport();
			getTabbedPane().setSelectedIndex(0);
			getBtnSwitch().setEnabled(false);
			getTabbedPane().setEnabledAt(1, false);
		}
	}

	private void placeResultToEditor() {
		getEditorPane().setText(calculator.getResultText());
	}

	@Override
	public void stateChanged(ChangeEvent e) {
		System.out.println();
		if (e.getSource() == getTabbedPane()) {
			if (refreshAll()) {
				getBtnPass().setEnabled(false);
			}
		}

	}

	/**
	 * sets the values of the configuration parameters
	 * 
	 * @return true in case all components are available
	 */
	private boolean refreshAll() {
		if (getEditorPane() != null) { /* is available after initialize() has been performed */
			calculator = getCalculator();
			selectedParams[0] = getChk1().isSelected();
			selectedParams[1] = getChk2().isSelected();
			selectedParams[2] = getChk3().isSelected();
			if (getRbt1().isSelected())
				selectedFactor = 1;
			if (getRbt2().isSelected())
				selectedFactor = 2;
			if (getRbt3().isSelected())
				selectedFactor = 5;
			return true;
		}
		return false;
	}

	public synchronized boolean[] getSelectedParams() {
		return selectedParams;
	}

	public synchronized int getSelectedFactor() {
		return selectedFactor;
	}

	public JButton getBtnClose() {
		return btnClose;
	}

	public JButton getBtnCalc() {
		return btnCalc;
	}

	public JButton getBtnPass() {
		return btnPass;
	}

	public JButton getBtnSwitch() {
		return btnSwitch;
	}

	public void setCalculator(TestFrameCalc testFrameCalc) {
		calculator = testFrameCalc;
	}

	private JPanel getPane1() {
		return panel1;
	}
}
